/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package sos.stresstest.dialogtest;

import sos.stresstest.dialogtest.DialogTesterBasic;
import sos.connection.SOSConnection;
import sos.util.SOSLogger;

/**
 * Basisklasse fr die Checker-Klassen eines DialogTests.<br>
 * Ein Objekt einer Klasse, die diese Klasse erweitert, wird
 * mittels Reflection in SOSDialogTest erzeugt.
 * 
 * @author fs
 * @since 18.03.2005
 */
public class SOSChecker extends DialogTesterBasic {
	
	/**
	 * Setzt eine Connection.<br>
	 * Wird von SOSDialogTest per Reflection aufgerufen.
	 * @param connection
	 */
	public final void setConnection(SOSConnection connection) {
		
		this.conn = connection;
	}
	
	/**
	 * Setzt einen Logger.<br>
	 * Wird von DialogTester per Reflection aufgerufen.
	 * @param logger
	 */
	public final void setSosLogger(SOSLogger logger) {
		
		this.sosLogger = logger;
	}
	
	
	/**
	 * Diese Methode kann implementiert werden, wenn HTML-Suchstrings fr DialogTester.checkHtml<br>
	 * und DialogTester.checkHtmlAbsent innerhalb der Checker-Klasse definert werden sollen.<br>
	 * Wird von SOSDialogTest erst nach dem evtl. Aufbau einer Connection aufgerufen.<br>
	 * Dadurch knnen HTML-Strings in Abhngigkeit von der Datenbank entstehen.
	 */
	public void initialize(DialogTester dt) throws Exception {
	}
}
