/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#define MODULE_NAME "ebcdicdu"
#define COPYRIGHT   "(c) SOS GmbH Berlin"
#define AUTHOR      "Joacim Zschimmer"

#include <stdio.h>                  // perror()
#include <string.h>

#include <sos.h>

extern Byte e2a_printable [256];

int main( int argc, char** argv )
{
    char                    hex_tab [256] [2];
    const char              hex_t [] = "0123456789ABCDEF";

    const int bytes_per_line    = 32;
    Byte     last_line          [ bytes_per_line ];
    Bool     last_line_valid    = false;
    char     repeat             = ' ';
    long     addr               = 0;

    for (int i = 0; i < 16; i++) {
        for (int j = 0; j < 16; j++) {
            hex_tab [i * 16 + j] [0] = hex_t [i];
            hex_tab [i * 16 + j] [1] = hex_t [j];
        }
    }


    while(1)
    {
        Byte buffer [ bytes_per_line ];

        cin.read( (char*)buffer, sizeof buffer );
        int length = cin.gcount();
        if( length == 0 )  break;

        if( memcmp( buffer, last_line, bytes_per_line ) == 0  &&  last_line_valid ) {
            repeat = '=';
        } else {
            char  line [ 4*bytes_per_line ];
            char* p;

            //memset( line, ' ', sizeof line );

            line[ 0 ] = repeat;
            *(uint2*)(line + 1) = *(uint2*)hex_tab[ (Byte) (addr >> 24) ];
            *(uint2*)(line + 3) = *(uint2*)hex_tab[ (Byte) (addr >> 16) ];
            *(uint2*)(line + 5) = *(uint2*)hex_tab[ (Byte) (addr >>  8) ];
            *(uint2*)(line + 7) = *(uint2*)hex_tab[ (Byte)  addr        ];
            line[ 9 ] = ' ';
            p = line + 10;

            for (int j = 0; j < length; j++) {
                if ((j & 3) == 0)  *p++ = ' ';
                int b = *( buffer + j );
                *(uint2*)p = *(uint2*)hex_tab[ b ];
                p += 2;
            }

            *p++ = ' ';
            *p++ = ' ';

            xlat( p, buffer, length, e2a_printable );
            p += length;
            *p++ = '\n';

            cout.write( line, p - line );
            if( cout.fail() )  goto error;

            memcpy( last_line, buffer, bytes_per_line );
            last_line_valid = true;
            repeat = ' ';
        }
        addr += bytes_per_line; 
    }

    if( cin.fail() )  goto error;
    
    cout << "        " << repeat << '\n';
    repeat = ' ';

    return 0;

  error:
    //? A perror();
    //cerr << "i/o error\n";
    return 1;  
}

