/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#include "precomp.h"
//#define MODULE_NAME "objfile"
//#define COPYRIGHT   " 1995 SOS GmbH Berlin"
//#define AUTHOR      "Joacim Zschimmer"


#include "../kram/sysdep.h"
//#include <except.h>         // Borland spezial

#include "../kram/sosstrng.h"
#include "../kram/sos.h"
#include "../kram/log.h"
#include "../kram/xception.h"
#include "../file/absfile.h"
#include "../file/anyfile.h"
#include "../file/filekey.h"

namespace sos {

//------------------------------------------------------------------------------------------statics

struct File_as_key_file_type : Abs_file_type
{
    virtual const char*         name                    () const { return "file_as_key"; }
  //virtual const char*         alias_name              () const { return ""; }
    virtual Sos_ptr<Abs_file>   create_base_file        () const
    {
        Sos_ptr<File_as_key_file> f = SOS_NEW_PTR( File_as_key_file );
        return +f;
    }
};

const File_as_key_file_type  _file_as_key_file_type;
const Abs_file_type&          file_as_key_file_type = _file_as_key_file_type;

//----------------------------------------------------------------------------File_as_key_file::open
/*
void File_as_key_file::open( const char* filename, Open_mode open_mode, const File_spec& file_spec )
{
}
*/
//---------------------------------------------------------------------------File_as_key_file::close
/*
void File_as_key_file::close( Close_mode close_mode )
{
}
*/
//------------------------------------------------------------------File_as_key_file::get_record_key

void File_as_key_file::get_record_key( Area& buffer, const Key& key )
{
    ASSERT_VIRTUAL( get_record_key )

    Any_file   file;
    Sos_string filename = as_string( key );

    file.open( c_str( filename ), File_base::Open_mode( File_base::in | File_base::seq ) );

    buffer.allocate_min( 32760 );
    Byte* p     = buffer.byte_ptr();
    Byte* p_end = p + buffer.size() - 2 /*fr \r\n*/;

    //try {
        while(1) {
            Area rest ( p, p_end - p );

            try {
                file.get( &rest );
            }
            catch( const Eof_error& )      { break; }
            catch( const Too_long_error& ) { break; }

            p += rest.length();

            for( int i = 0; i < rest.length(); i++ )  if( rest.char_ptr()[ i ] != ' ' )  break;
            //jz 7.4.97 if( i == rest.length() ) {   // Leerzeile?
                if( p + 2 > p_end )  throw_too_long_error();
#               if defined SYSTEM_WIN
                    *p++ = '\r';
#               endif
                *p++ = '\n';
                continue;
            //jz 7.4.97 } else {
            //jz 7.4.97     *p++ = ' ';
            //jz 7.4.97 }
        }

        buffer.length( p - buffer.byte_ptr() );

/* Folgender Code wirkt bei Borland nicht (ohne oben stehende catchs):
    }
    catch( const Eof_error& x )
    {
        buffer.length( p - buffer.byte_ptr() );
    }
    catch( ... )
    {
        int BORLAND_SPEZIAL_EXCEPTION;  // ?? jz 29.8.95
        if( strcmp( __throwExceptionName, "D310" ) != 0 )  throw;
        buffer.length( p - buffer.byte_ptr() );
    }
*/
    file.close();
}

//----------------------------------------------------------------------File_as_key_file::put_record
/*
void File_as_key_file::put_record( const Const_area& record )
{

}
*/


} //namespace sos
