/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// fileobj.h                     1995 SOS GmbH Berlin

#ifndef __FILEOBJ_H
#define __FILEOBJ_H

#if !defined __SOSFILTR_H
#   include "../kram/sosfiltr.h"
#endif

#if !defined __RAPID_H
#   include "../fs/rapid.h"
#endif

#if !defined __ABSFILE_H
#   include "absfile.h"
#endif

namespace sos {

//-------------------------------------------------------------------------------------Sos_file

struct Sos_file : Sos_msg_filter // ?
{
    BASE_CLASS( Sos_msg_filter )

  protected:
    Bool                       _obj_is_type             ( Sos_type_code t ) const   { return t == tc_Sos_file || Base_class::_obj_is_type( t ); }
};

//-------------------------------------------------------------------------------Get_direct_msg

struct Get_direct_msg : Get_msg
{
                                Get_direct_msg          ( Sos_object*, Sos_object*,
                                                          const Const_area_handle& key );

    const Const_area_handle&    key                     () const  { return _key; }  
    Rapid::Parflget::Flags     _flags;
    uint4                      _position;       // -1, oder seek()-Wert oder Satznummer
    Const_area_handle          _key;
  //Const_area_handle          _key_end;
  //Sos_string                 _name;           // evtl. SQL-SELECT?
    int4                       _record_count;   // Geschtzte Anzahl erwarteter Stze
};

typedef Get_direct_msg T_get_direct_msg;

//------------------------------------------------------------------------------------Store_msg
/*
struct Store_msg : Data_msg
{
    Rapid::Parflput::Flags     _flags;
    uint4                      _position;       // -1, oder seek()-Wert oder Satznummer
    Const_area_handle          _key;
};
*/
////////////////////////////////////////////////////////////////////////////////////////INLINES

inline Get_direct_msg::Get_direct_msg( Sos_object* dest, Sos_object* source,
                                       const Const_area_handle& key )
:
    Get_msg ( msg_get_direct, dest, source ),
    _key ( key )
{
};

} //namespace sos
#endif
