/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// fldfile.cxx
#include "precomp.h"
#if 0

#include <sos.h>
#include <sosfield.h>


#include <fldfile.h>


struct Field_file : Abs_file
{
    static void                     print_field_names( ostream* s, const Field_type& record_type,
                                                       const char* name = "", const char* separator = ", "
                                                     )
 protected:
    // Methoden zum Zugriff ???
    const Field_type*               _record_type_ptr;
    const Field_descr*              _key_descr_ptr;
};


//------------------------------------------------------------------------- print_name

static void print_name( ostream* s, const char* n )
{
    // Ersetzen von Minuszeichen in Unterstriche (Konvention ?)
    char c;
    while( c = *n++ )  s->put( (char)( c == '-' ? '_' : c ) );
}


// --------------------------------------------------------------- Field_file::print_field_names

void Field_file::print_field_names( ostream* s, const Field_type& record_type, const char* name, const char* separator  )
{
    if ( record_type.field_count() == 0 ) {
        if ( name[0] == 0 ) throw Xc( "print_field_names" );
        print_name( s, name );
    } else
    {
        for( int i = 0; i < record_type.field_count(); i++ )
        {
            const Field_descr& field_descr = record_type.named_field_descr( i );

            if( i > 0 )  *s << separator; // ", "
            print_field_names( s, field_descr.type(), field_descr.name() );
        }
    }
}


#endif
