/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// flstream.h                   1996 SOS GmbH Berlin

#ifndef __FLSTREAM_H
#define __FLSTREAM_H

#ifndef __ANYFILE_H
#   include "anyfile.h"
#endif

namespace sos {


//---------------------------------------------------------------------------Any_file_streambuf

struct /*_CLASSTYPE Borland*/ Any_file_streambuf : std::streambuf
{
                                Any_file_streambuf      ();
                                Any_file_streambuf      ( const Any_file& );
                               ~Any_file_streambuf      ();

    void                        init                    ( const Any_file& );
    void                        open                    ( const Sos_string& filename, Any_file::Open_mode mode );
    void                        close                   ( Close_mode mode = close_normal );

    virtual int _Cdecl          sync                    ();
    virtual int _Cdecl          underflow               ();
    virtual int _Cdecl          overflow                ( int = EOF );

  protected:
    Sos_ptr<Any_file>          _any_file;
    Dynamic_area               _read_buffer;
    Dynamic_area               _write_buffer;
    Bool                       _close_it;
};

//------------------------------------------------------------------------------Any_file_stream

struct Any_file_stream : private Any_file_streambuf, public std::iostream
{
                                Any_file_stream         ();
                                Any_file_stream         ( const Any_file& );
                               ~Any_file_stream         ();

    void                        init                    ( const Any_file& file )                { Any_file_streambuf::init( file ); }
    void                        open                    ( const Sos_string& filename, Any_file::Open_mode mode )  { Any_file_streambuf::open( filename, mode ); }
    void                        close                   ( Close_mode mode = close_normal )      { Any_file_streambuf::close( mode ); }
    bool                        opened                  () const                                { return _any_file && _any_file->opened(); }
};


} //namespace sos

#endif

