/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#ifndef __KEYARRAY_H
#define __KEYARRAY_H

//-----------------------------------------------------------------------------------Key_buffer

struct Fixed_length_key_array : Sos_self_deleting
{
                                    Fixed_length_key_array( const Sos_ptr<Field_type>& );
                                   ~Fixed_length_key_array();

    Byte*                           operator []         ( int );
    int                             operator []         ( const Byte* );
    void                            add                 ( const Byte* );
    void                            last_index          ( int );

    Fill_zero                      _zero_;
  //DECLARE_PRIVATE_MEMBER( int,    first_index )
    void                            first_index         ( int i )   { _array.first_index( i ); }
    int                             first_index         () const    { return _array.first_index(); }
  //DECLARE_PRIVATE_MEMBER( int,    allocation_increment )

  private:
    //Dynamic_area                   _buffer;
    Sos_simple_array<Byte*>        _array;
    Sos_ptr<Field_type>            _type;
    int                            _entry_size;
};

//-----------------------------------------------------------Fixed_length_key_array::operator[]

inline Byte* Fixed_length_key_array::operator[] ( int i )
{
    //return _buffer.byte_ptr() + ( i - _first_index ) * _entry_size;
    return _array[ i ];
}

#endif
