/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#define MODULE_NAME "odbcinst"
#define COPYRIGHT   "1997 SOS GmbH Berlin"
#define AUTHOR      "Jrg Schwiemann"

// ODBCINST-SQL-Zugriffe

// Datum: 14. 9.1994
// Stand:  4.12.1995

#include <precomp.h>
#include <stdio.h>
#include <sysdep.h>

#if defined SYSTEM_WIN       // gesamtes odbcinst.cxx

#include <string.h>

#if defined SYSTEM_MICROSOFT
#   error
#   include <afx.h>
#else
#   define STRICT
#   include <windows.h>
#endif

// ODBCINST-Interface
extern "C" {
#   include <sqlext.h>
#   include <sql.h>
#   include <odbcinst.h>
}

#include <sosstrng.h>
#include <sos.h>

#include <sosprof.h>
#include <sosopt.h>
#include <sosarray.h>
#include <stdfield.h>
#include <log.h>
#include <sosdate.h>
#include <absfile.h>
#include <sosdll.h>
#include <sosdb.h>
#include <odbctype.h>

// ----------------------------------------------------------------------------- Odbcinst_functions

struct Odbcinst_functions : Sos_self_deleting, Sos_dll
{
                                DECLARE_AUTO_LOADING_DLL_PROC_4(    BOOL INSTAPI, SQLConfigDataSource,
                                                                    HWND       /*hwndParent*/,
                                                                    WORD       /*fRequest*/,
                                                                    LPCSTR     /*lpszDriver*/,
                                                                    LPCSTR     /*lpszAttributes*/ );
};

#define ODBCINST_LIB _odbcinst_static._lib.


//----------------------------------------------------------------------------------Odbcinst_static

struct Odbcinst_static
{
                                Odbcinst_static          ();
                               ~Odbcinst_static          ();

    Odbcinst_static*            static_ptr               ()                                     { return this; }
    void                        init();

    Odbcinst_functions          _lib;
};

static Odbcinst_static _odbcinst_static;

//---------------------------------------------------------------------Odbcinst_static::Odbcinst_static

Odbcinst_static::Odbcinst_static()
{
}

//---------------------------------------------------------------------Odbc_static::~Odbc_static

Odbcinst_static::~Odbcinst_static()
{
}

//---------------------------------------------------------------------Odbcinst_static::Odbcinst_static

void Odbcinst_static::init()
{
#   if defined SYSTEM_WIN16
        _lib.init( "ODBCINST.DLL" );
#   else
#error
        _lib.init( "ODBCINST32.DLL" );
#   endif
}


Bool repair_access_db( HWND parent, const Sos_string& pfad )
{
    _odbcinst_static.init();
    Sos_string attr = "REPAIR_DB=";
    attr += pfad;
    BOOL b = ODBCINST_LIB SQLConfigDataSource( parent, ODBC_CONFIG_DSN, "ODBCJT16.DLL", c_str(attr) );
    return b ? true : false;
}


#endif // defined SYSTEM_WIN
