/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// recstrea.h
//                                                      Joacim Zschimmer

#ifndef __RECSTREA_H
#define __RECSTREA_H

#ifndef __AREA_H
#   include <area.h>
#endif

#ifndef __STREAM_H
#   include <stream.h>
#endif


#define DECLARE_RECORD_STREAM_OPERATIONS(Type)                           \
    DECLARE_INPUT_STREAM_OPERATIONS( Type )                              \
    DECLARE_OUTPUT_STREAM_OPERATIONS( Type )


struct __huge Record_stream;

#if !defined _CLASSTYPE      // _CLASSTYPE wird von Borland C++ 4.0 verwendet
#   define _CLASSTYPE
#endif

class _CLASSTYPE Record_streambuf : public streambuf
{
  public:
    Record_streambuf( Record_stream _FAR *, uint max_record_size = 2048  );
    ~Record_streambuf();

    virtual int _Cdecl sync();
    virtual int _Cdecl underflow();
    virtual int _Cdecl overflow( int = EOF );

  private:
    const int                _buffer_size;
    Dyn_area< char >         _buffer;
    Record_stream* const     _f;
    Bool                     _get_next_record;
};


struct __huge Record_stream : Streambuf_stream
{
    Record_stream();
    ~Record_stream() {}

    unsigned int  skip_record        ();                 // ???

  protected:
    virtual void put_record( const Const_area& ) = 0;
    virtual void get_record( Area&             ) = 0;
    friend class Record_streambuf;

  private:
    Record_streambuf       _record_streambuf;
};


#include "recstrea.inl"
#endif

