/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// Soscopy_dialog.cxx : implementation file
//

#include "afxwin.h"

#include <sosstrng.h>
#include <sos.h>
#include <msec.h>
#include <soscopy.h>
#include "soscopy.hrc"
#include <Soscopy_copying_dialog.h>
#include "Soscopy_dialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Soscopy_dialog dialog


Soscopy_dialog::Soscopy_dialog(CWnd* pParent /*=NULL*/)
: 
    CDialog(Soscopy_dialog::IDD, pParent),
    _zero_(this+1)

{
	//{{AFX_DATA_INIT(Soscopy_dialog)
	//}}AFX_DATA_INIT

    _ids_copy_finished.LoadString( IDS_COPY_FINISHED );
}


Soscopy_dialog::~Soscopy_dialog()
{
    SOS_DELETE( _copying_dlg );
}


void Soscopy_dialog::mini_title( const Sos_string& title )
{
    if( _use_mini_title )  SetWindowText( title );
}


BEGIN_MESSAGE_MAP(Soscopy_dialog, CDialog)
	//{{AFX_MSG_MAP(Soscopy_dialog)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Soscopy_dialog message handlers

void Soscopy_dialog::OnClose() 
{
    _abort = true;
    DestroyWindow();

	//CDialog::OnClose();
}


void Soscopy_dialog::OnOK() 
{
    if( _locked )  return;
    _locked++;

    EnableWindow( FALSE );
    Sos_string text;

    GetDlgItemText( IDC_INPUT , app._input_filename );
    GetDlgItemText( IDC_OUTPUT, app._output_filename );

    GetDlgItemText( IDC_SKIP  , text );
    try {
        app._skip = empty( text )? 0 : as_long( text );
    }
    catch( const Xc& x ) {
        return;
    }

    GetDlgItemText( IDC_COUNT , text );
    try {
        app._count = empty( text )? -1 : as_long( text );
    }
    catch( const Xc& x ) {
        return;
    }


    Soscopy_copying_dialog copying_dlg ( this );
    copying_dlg.Create( IDD_COPYING_DIALOG, this );
    //copying_dlg.SetFocus();
    //copying_dlg.ShowWindow( SW_SHOW );
    //copying_dlg.UpdateWindow();

    //MSG msg;
    //while( ::PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )  app.PumpMessage();

    try {
        uint4 start_msec = elapsed_msec();

        uint4 count = app.copy_file( &copying_dlg );

        copying_dlg.stop_timer();
        copying_dlg.EnableWindow( FALSE );

        char buffer [ 200 ];
        sprintf( buffer, c_str( _ids_copy_finished ), count, (double)( elapsed_msec() - start_msec ) / 1000 );
        SetDlgItemText( IDC_STATUS, buffer );
    }
    catch( const Xc& x )
    {
        SHOW_MSG( x );
    }
	//CDialog::OnOK();

    EnableWindow();
    _locked--;
}

void Soscopy_dialog::OnCancel() 
{
    _abort = true;
    //DestroyWindow();
	
	//CDialog::OnCancel();
}


void Soscopy_dialog::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);

    if( nType == SIZE_MINIMIZED  ||  nType == SIZE_MAXHIDE ) {
        _use_mini_title = true;
        SetWindowText( _mini_title );
    }
    else
    if( _use_mini_title ) {
        _use_mini_title = false;
        SetWindowText( "SOSCOPY" );
    }
}
