/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// fsman.h      FS-Manager                            (C)1996 SOS GmbH Berlin
//                                                    Joacim Zschimmer

#ifndef __FSMAN_H
#define __FSMAN_H

#ifndef __SOSARRAY_H
#   include "../kram/sosarray.h"
#endif

#ifndef __SOSOBJ_H
#   include "../kram/sosobj.h"
#endif

#ifndef __SOSMSG_H
#   include "../kram/sosmsg.h"
#endif

namespace sos {

//---------------------------------------------------------------------------------------static

extern const int4  max_demo_connections;
extern ostream*    fs_log;

//------------------------------------------------------------------------------------Fs_manager

struct Fs_manager : Sos_object
{
    BASE_CLASS( Sos_object )

                                Fs_manager              ( const Sos_string& port );
                               ~Fs_manager              ();

    enum Conn_status
    {
        sta_none,
        sta_creation,
        sta_running,
        sta_closing
    };

    void                        start                   ();
  protected:
    SOS_DECLARE_MSG_DISPATCHER
    #if !defined SYSTEM_RTTI
        void                   _obj_print               ( ostream* s ) const  { *s << "Fs_manager"; }
    #endif

  private:
    void                       _obj_run_msg             ( Run_msg* );
    void                       _obj_ack_msg             ( Ack_msg* );
    void                       _obj_error_msg           ( Error_msg* );

    void                        request_connection      ();

    struct Connection
    {
                                Connection              ( const Sos_object_ptr& c = Sos_object_ptr( NULL ), Conn_status s=sta_none ) : _conn(c), _status(s) {}

        Sos_object_ptr         _conn;
        Conn_status            _status;
    };

    Fill_zero                  _zero_;
    Sos_string                 _port;
    Sos_simple_array<Connection> _connection_array;
    Bool                       _first_request_logged;

  public:
    Sos_string                 _filename_prefix;
    int4                       _allowed_connections_count;
};


} //namespace sos
#endif

