/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// init.h                                               (c) SOS GmbH Berlin

#ifndef __INIT_H
#define __INIT_H

#include "sysdep.h"

struct Sos_init_parameters {
  Sos_init_parameters();
  ~Sos_init_parameters();

  struct Host_connection {
    char userid[8+1];
    char account[8+1];
    char password[19+1];
    char logon_parameters[100+1];
    char remtiam[100+1];
  };

  struct Fileserver {
    char name[8+1];
  };

  struct Tcp {
    char hostname[15+1];
  };

  const char* sos_filename();

  // Methoden
  void init();

  int init_ok() { return _init_ok; };

  const char* getenv( const char* );

  void set_group( const char* group );

  void read( char* r, int len,
             const char* name,
             const char* def = "" );

  unsigned int read_int( const char* name, const unsigned int def );

  int check_flag( const char* name, int def = 0 );

  void set( const char* item, 
            const char* value );

  // Groups
  Host_connection _host_connection;
  Fileserver      _fileserver;
  Tcp             _tcp;


private:
  int _init_ok;
  int _is_demo;
  int _file_exists( const char* );
  char _demo_path[256];

#if defined(SYSTEM_SOLARIS)
  void* pIniFile;
#endif  

#if defined(SYSTEM_WIN)
//StarView      void* pIniFile;
  char group[256];
  char filename[256];
#endif
};

void init_sos_parameters();


extern Sos_init_parameters sos_init_parameters;

#endif

