/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// integer8.h                                    (c) SOS GmbH Berlin
//                                                   Joacim Zschimmer

#ifndef __INTEGER8_H
#define __INTEGER8_H

namespace sos
{

struct Sos_binary_istream;

struct Integer8
{
                                Integer8                ( int4 );

    friend void                 read_integer8           ( Sos_binary_istream*, Integer8* );
    friend void                 write_integer8          ( Sos_binary_ostream*, const Integer8& );

  private:
    int4                       _high4;
    uint4                      _low4;
};

//==========================================================================================inlines

inline Integer8::Integer8( int4 i )
:
    _high4 ( i < 0? -1 : 0  ),
    _low4  ( (uint4)i )
{
}

#if defined __SOSSTREA_H

inline void read_integer8( Sos_binary_istream* s, Integer8* integer8_ptr )
{
    read_int4 ( s, &integer8_ptr->_high4 );
    read_uint4( s, &integer8_ptr->_low4  );
}


inline void write_integer8( Sos_binary_ostream* s, const Integer8& integer8 )
{
    write_int4 ( s, integer8._high4 );
    write_uint4( s, integer8._low4  );
}

#endif

} //namespace sos

#endif
