/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#include "precomp.h"
//#define MODULE_NAME "nullasgn"
// 1.9.92                                                       Joacim Zschimmer

#include "sysdep.h"

#if defined SYSTEM_DOS

#include <stdlib.h>
#include <string.h>

#include "jzincl.h"
#include "nullasgn.h"

using namespace std;
namespace sos {

//-----------------------------------------------------------------------------

Null_pointer_assignment null_pointer_assignment;

//-----------------------------------------------------------------------------

Null_pointer_assignment::Null_pointer_assignment()
{
    initialized = false;
}

//-----------------------------------------------------------------------------

void Null_pointer_assignment::init()
{
    initialized = false;
}

//-----------------------------------------------------------------------------

int Null_pointer_assignment::operator() ()
{
#   if defined SYSTEM_DOS  &&  !defined SYSTEM_WIN
        if (!initialized) {
            memcpy( null_data, (void*)0, sizeof null_data );
            initialized = true;
        }
        return memcmp( null_data, (void*)0, sizeof null_data );
#    else
        return 0;
#   endif
}

} //namespace sos

#endif
