/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#include "precomp.h"
//#define MODULE_NAME "profile"
// profile.cpp                                          (c) SOS GmbH Berlin
//                                                          Joacim Zschimmer

#if 0

#include <cstring.h>
#include <windows.h>

#include <sos.h>
#include <xception.h>

#include <profile.h>

//-------------------------------------------Profile::Section::Section

Profile::Section::Section( const string& filename, const string& section_name )
:
    _filename     ( filename ),
    _section_name ( section_name )
{
}

//-------------------------------------------Profile::Section::Entry::operator=

Profile::Section::Entry::~Entry()
{
    if( _my_section ) {
        delete _section_ptr;
    }
}

//-------------------------------------------Profile::Section::Entry::operator=
/*
void Profile::Section::Entry::operator= ( const Storable_as<string>& value )
{
    string value_string;
    value.object_store( &value_string );

    WritePrivateProfileString( _section_ptr->section_name().c_str(),
                               _entry_name.c_str(),
                               value_string.c_str(),
                               _section_ptr->filename().c_str()
                             );
}
*/
//-------------------------------------------Profile::Section::Entry::operator=

void Profile::Section::Entry::operator= ( const string& value )
{
    WritePrivateProfileString( _section_ptr->section_name().c_str(),
                               _entry_name.c_str(),
                               value.c_str(),
                               _section_ptr->filename().c_str()
                             );
}

//------------------------Profile::Section::Entry::void operator string

Profile::Section::Entry::operator string() const
{
     char value [ max_profile_section_entry_value_length + 1 ];

     value[ 0 ] = '\0';

     GetPrivateProfileString( _section_ptr->section_name().c_str(),
                              _entry_name.c_str(),
                              _default_value.c_str(),
                              value, sizeof value,
                              _section_ptr->filename().c_str()
                            );

     return string( value );
}

//-------------------------------------------------Profile::Section::Entry::get

#if 0   // Ab Borland 4.0 bersetzungsfehler
void Profile::Section::Entry::get( Typed* value_ptr ) const
{
    String value_string = *this;
    (istrstream) (Const_string_area) value_string >> *value_ptr;
}
#endif

#endif
