/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#include "precomp.h"
//#define MODULE_NAME "sosctype"
//#define COPYRIGHT   "1995 SOS GmbH Berlin"
//#define AUTHOR      "Joacim Zschimmer"

//#include "../kram/ctype.h>
#include "../kram/sos.h"
#include "tabucase.h"
#include "sosctype.h"
#include "log.h"

using namespace std;
namespace sos {



char           tabucase_   [256];
char           tablcase_   [256];
unsigned char  sosctype_tab[1+256];     // incl. EOF (-1)


static
struct Sosctype_init
{
    Sosctype_init();
} x;


Sosctype_init::Sosctype_init()
{
    for( int i = 0  ; i <= 255; i++ )  {
        //13.1.97 if( isspace( i ) )  sosctype_tab[ 1 + i ] |= SOS_IS_SP;
        tabucase_[ i ] = (char)i;
        tablcase_[ i ] = (char)i;
    }

    sosctype_tab[ 1 + (unsigned)' '  ] |= SOS_IS_SP;
    sosctype_tab[ 1 + (unsigned)'\t' ] |= SOS_IS_SP;
    sosctype_tab[ 1 + (unsigned)'\v' ] |= SOS_IS_SP;
    sosctype_tab[ 1 + (unsigned)'\r' ] |= SOS_IS_SP;
    sosctype_tab[ 1 + (unsigned)'\n' ] |= SOS_IS_SP;
    sosctype_tab[ 1 + (unsigned)'\f' ] |= SOS_IS_SP;


    const unsigned char* k;

  //sosctype_tab[ (unsigned)'' &= ~SOS_IS_HIGH;   // ???


    k = (unsigned char*) "0123456789";
    while( *k )  sosctype_tab[ 1 + *k++ ] |= SOS_IS_DIG | SOS_IS_HEX | SOS_IS_GRAPH;

    k = (unsigned char*) "aAbBcCdDeEfFgGhHiIjJkKlLmMnNoOpPqQrRsStTuUvVwWxXyYzZ"
                         "";
                       //"";
                       //"";   // ist das auch ISO-8859-1? (0x81..0x9F)

    while( *k ) {
        sosctype_tab[ 1 + *k    ] |= SOS_IS_LOW | SOS_IS_GRAPH;
        sosctype_tab[ 1 + *(k+1)] |= SOS_IS_UPP | SOS_IS_GRAPH;
        tabucase_[ *k     ] = (char)*(k+1);
        tablcase_[ *(k+1) ] = (char)*k;
        k += 2;
    }

    sosctype_tab[ 1 + (unsigned char)'' ] |= SOS_IS_LOW;

    k = (unsigned char*) "abcdefABCDEF";
    while( *k )  sosctype_tab[ 1 + *k++ ] |= SOS_IS_HEX;

    for( int m = 0; m < (unsigned)' '; m++ )  sosctype_tab[ 1 + m ] |= SOS_IS_CTL;

    k = (unsigned char*) "!\"#$%&'()*+,-./:;<=>?@[\\]^_`{|}~"
                         //""       // ist das auch ISO-8859-1? (0x81..0x9F)
                         "";

    while( *k )  sosctype_tab[ 1 + *k++ ] |= SOS_IS_GRAPH;

    sosctype_tab[ 1 + (unsigned)' ' ] |= SOS_IS_BLK;
}

} //namespace sos
