/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
/*  ctype.h

    Defines the locale aware ctype macros.

*/

/*
 *      C/C++ Run Time Library - Version 6.5
 *
 *      Copyright (c) 1987, 1994 by Borland International
 *      All Rights Reserved.
 *
 *      Verndert, jz 8.10.95
 */

#ifndef __SOSCTYPE_H
#define __SOSCTYPE_H

namespace sos
{

extern unsigned char sosctype_tab[ 257 ];

/* character classes */

#define SOS_IS_SP     1           /* space */
#define SOS_IS_DIG    2           /* digit */
#define SOS_IS_UPP    4           /* upper case */
#define SOS_IS_LOW    8           /* lower case */
#define SOS_IS_HEX   16           /* [0..9] or [A-F] or [a-f] */
#define SOS_IS_CTL   32           /* control */
#define SOS_IS_GRAPH 64           /* darstellbares Zeichen */
#define SOS_IS_BLK  128           /* blank */

#define SOS_IS_ALPHA    (SOS_IS_UPP | SOS_IS_LOW)
#define SOS_IS_ALNUM    (SOS_IS_DIG | SOS_IS_ALPHA)
//#define SOS_IS_GRAPH    (SOS_IS_ALNUM | SOS_IS_HEX | SOS_IS_PUN)

inline int sos_isalnum( int c )   { return sosctype_tab[ c + 1 ] & (SOS_IS_ALNUM); }
inline int sos_isalnum( char c )  { return sos_isalnum( (int)(unsigned char)c ); }

inline int sos_isalpha( int c )   { return sosctype_tab[ 1 + c ] & (SOS_IS_ALPHA); }
inline int sos_isalpha( char c )  { return sos_isalpha( (int)(unsigned char)c ); }

inline int sos_iscntrl( int c )   { return sosctype_tab[ 1 + c ] & (SOS_IS_CTL); }
inline int sos_iscntrl( char c )  { return sos_iscntrl( (int)(unsigned char)c ); }

inline int sos_isdigit( int c )   { return sosctype_tab[ 1 + c ] & (SOS_IS_DIG); }
inline int sos_isdigit( char c )  { return sos_isdigit( (int)(unsigned char)c ); }

inline int sos_isgraph( int c )   { return sosctype_tab[ 1 + c ] & (SOS_IS_GRAPH); }
inline int sos_isgraph( char c )  { return sos_isgraph( (int)(unsigned char)c ); }

inline int sos_islower( int c )   { return sosctype_tab[ 1 + c ] & (SOS_IS_LOW); }
inline int sos_islower( char c )  { return sos_islower( (int)(unsigned char)c ); }

inline int sos_isprint( int c )   { return sosctype_tab[ 1 + c ] & (SOS_IS_GRAPH | SOS_IS_BLK); }
inline int sos_isprint( char c )  { return sos_isprint( (int)(unsigned char)c ); }

//inline int sos_ispunct( int c )   { return sosctype_tab[ 1 + c ] & (SOS_IS_PUN); }
inline int sos_isspace( int c )   { return sosctype_tab[ 1 + c ] & (SOS_IS_SP); }
inline int sos_isspace( char c )  { return sos_isspace( (int)(unsigned char)c ); }

inline int sos_isupper( int c )   { return sosctype_tab[ 1 + c ] & (SOS_IS_UPP); }
inline int sos_isupper( char c )  { return sos_isupper( (int)(unsigned char)c ); }

inline int sos_isxdigit( int c )  { return sosctype_tab[ 1 + c ] & (SOS_IS_HEX); }
inline int sos_isxdigit( char c ) { return sos_isxdigit( (int)(unsigned char)c ); }

inline int sos_isctype( int c, int type )  { return sosctype_tab[ 1 + c ] & type; }
inline int sos_isctype( char c, int type ) { return sos_isctype( (int)(unsigned char)c, type ); }


} //namespace sos

#endif /* __CTYPE_H */
