/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// sosobj.h                                                 1995 SOS GmbH Berlin

#ifndef __SOSFILTR_H
#define __SOSFILTR_H

#if !defined __SOSOBJ_H
#   include "sosobj.h"
#endif

#if !defined __SOSMSG_H
#   include "sosmsg.h"
#endif

namespace sos
{

struct Sos_read_blocker;

//-------------------------------------------------------------------------------Sos_msg_filter

struct Sos_msg_filter : Sos_object   // Filter-Objekt mit Standard-Eingabe und -Ausgabe
{
    BASE_CLASS( Sos_object )
                              //Sos_msg_filter          ( Sos_msg_filter* input = 0, Sos_msg_filter* output = 0 );
                               ~Sos_msg_filter          ();
/*
    void                        obj_pipe_out            ( Sos_msg_filter* );
    void                        obj_pipe_in             ( Sos_msg_filter* );

    DECLARE_PUBLIC_MEMBER( Sos_msg_filter*, obj_input_ptr  )
    DECLARE_PUBLIC_MEMBER( Sos_msg_filter*, obj_output_ptr )
*/
  //void                        obj_pipe_out            ( Sos_object* );

    const Sos_object_ptr&       obj_output_ptr          () const                    { return _obj_output_ptr; }
    void                        obj_output_ptr          ( const Sos_object_ptr& p ) { _obj_output_ptr = p; }
    Sos_msg_filter*             obj_reverse_filter      ( Sos_msg_filter* client = 0 );
  //Sos_read_blocker*           obj_read_blocker        () const            { return (Sos_read_blocker*)+_obj_read_blocker; }

  protected:
    Bool                       _obj_is_type             ( Sos_type_code t ) const { return t == tc_Sos_msg_filter || Base_class::_obj_is_type( t ); }
    void                       _obj_msg                 ( Sos_msg* );

    void                        obj_created             ()                  { obj_reply_ack(); }
    void                        obj_not_created         ( const Xc& x )     { obj_reply_error( x ); }
  //Bool                        obj_reblock             ( Data_msg* );
    void                        obj_send                ( const Const_area& );    // Data_msg
    void                        obj_send                ( const Const_area&, uint4 seek_pos );    // Data_msg
    void                        obj_send                ( const Const_area&, const Const_area_handle& key );    // Data_msg
    void                        obj_request_end         ();
    void                        obj_reply_ack           ();
    void                        obj_reply_error         ( const Xc& );
  //void                        obj_send_ack            ();         // VORSICHT, REKURSION!

    virtual Const_area_handle  _obj_client_name         () const;

    virtual Sos_ptr<Sos_msg_filter> _obj_create_reverse_filter( Sos_msg_filter* client = 0 );

    Sos_object_ptr             _obj_client_ptr;
    Sos_ptr<Sos_msg_filter>    _obj_reverse_filter;
    Sos_object_ptr             _obj_output_ptr;

  private:
  //Sos_object_ptr             _obj_read_blocker;
};

//==========================================================================================inlines

//---------------------------------------------------------------------Sos_msg_filter::obj_pipe_out
/*
inline void Sos_msg_filter::obj_pipe_out( Sos_object* out )
{
    obj_output_ptr( out );
    //out->obj_input_ptr( this );
}
*/
//----------------------------------------------------------------------Sos_msg_filter::obj_pipe_in
/*
inline void Sos_msg_filter::obj_pipe_in( Sos_msg_filter* in )
{
    obj_input_ptr( in );
    in->obj_output_ptr( this );
}
*/
//-------------------------------------------------------------------Sos_msg_filter::Sos_msg_filter
/*
inline Sos_msg_filter::Sos_msg_filter( Sos_msg_filter* in, Sos_msg_filter* out )
:
    _obj_output_ptr    ( out ),
    _obj_read_blocker_ptr ( 0   )
{
}
*/


} //namespace sos

#endif
