/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// sosfld2.h                                    1996, SOS GmbH Berlin

#ifndef __SOSFLD2_H
#define __SOSFLD2_H

#ifndef __SOSFIELD_H
#   include "sosfield.h"
#endif

#ifndef __SOSLIMTX_H
#   include "soslimtx.h"
#endif

namespace sos
{

//---------------------------------------------------------------------------------As_bool_type

struct As_bool_type : Field_subtype
{
                                As_bool_type            ( const Sos_ptr<Field_type>& base_type, const Sos_string& falsch, const Sos_string& wahr );

    Bool                        null                    ( const Byte* ) const;
    void                        write_text              ( const Byte*, Area*, const Text_format& ) const;
    void                        read_text               ( Byte*, const char*, const Text_format& ) const;

  //static Type_info           _type_info;

  protected:
    void                       _obj_print               ( ostream* s ) const;

    Sos_limited_text<30>       _falsch;
    Sos_limited_text<30>       _wahr;
};

//------------------------------------------------------------------------------As_numeric_type

struct As_numeric_type : Field_subtype
{
                                As_numeric_type         ( const Sos_ptr<Field_type>& base_type );

    bool                        null                    ( const Byte* ) const;
    void                        set_null                ( Byte* ) const;
    void                        write_text              ( const Byte*, Area*, const Text_format& ) const;
    void                        read_text               ( Byte*, const char*, const Text_format& ) const;
};

//------------------------------------------------------------------------------As_decimal_type

struct As_decimal_type : Field_subtype
{
                                As_decimal_type         ( const Sos_ptr<Field_type>& base_type, int precision = 0, int scale = 0, bool nullable = true );

    bool                        null                    ( const Byte* ) const;
    void                        set_null                ( Byte* ) const;
    void                        write_text              ( const Byte*, Area*, const Text_format& ) const;
    void                        read_text               ( Byte*, const char*, const Text_format& ) const;
    void                       _get_param               ( Type_param* ) const;
    bool                        nullable                () const                                { return _nullable; }

    int                        _precision;
    int                        _scale;
    bool                       _nullable;
};

//---------------------------------------------------------------------------------As_text_type

struct As_text_type : Field_subtype
{
                                As_text_type            ( const Sos_ptr<Field_type>& base_type, int size = 0 );

    void                        write_text              ( const Byte*, Area*, const Text_format& ) const;
    void                        read_text               ( Byte*, const char*, const Text_format& ) const;

  //static Type_info           _type_info;

  protected:
    int                        _size;
};

//-------------------------------------------------------------------------As_saacke_posnr_type

struct As_saacke_posnr_type : Field_subtype
{
                                As_saacke_posnr_type    ( const Sos_ptr<Field_type>& base_type );

    void                        write_text              ( const Byte*, Area*, const Text_format& ) const;
    void                        read_text               ( Byte*, const char*, const Text_format& ) const;

  //static Type_info           _type_info;
};


} //namespace sos

#endif
