/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#include <precomp.h>
#define MODULE_NAME "soslist2"
/* soslist.cpp                                          (c) SOS GmbH Berlin
                                                        Joacim Zschimmer
*/

#if 0

#include <sos.h>
#include <xception.h>
#include <soslist.h>

//------------------------------------------------------------Sos_simple_list_0::~Sos_simple_list_0

Sos_simple_list_0::~Sos_simple_list_0()
{
    Sos_simple_list_0_elem* p = elem_ptr();

    while( p ) {
        Sos_simple_list_0_elem* p2 = p->tail().elem_ptr();
        p->_tail._elem_ptr = 0;
        if( --p2->_ref_count ) {
            delete p;
        }    
        p = p2;
    }
}

//------------------------------------------------------------------------Sos_simple_list_0::length

int Sos_simple_list_0::length() const
{
    int                 n = 0;
    Sos_simple_list_0   p = *this;

    while( !p.empty() ) {
        n++;
        p = p->tail();
    }

    return n;
}

//---------------------------------------------------------------------Sos_simple_list_0_elem::last

Sos_simple_list_0 Sos_simple_list_0_elem::last()
{
    Sos_simple_list_0 p = Sos_simple_list_0( this );

    while( !p->tail().empty() ) {
        p = p->tail();
    }

    return p;
}

//------------------------------------------------------------------------Sos_simple_list<T>::store

template< class T >
void Sos_simple_list<T>::store( ostream& s )
{
    uint4 count = length();
    s << (Byte) (count >> 24)
      << (Byte) (count >> 16)
      << (Byte) (count >> 8)
      << (Byte)  count;

    const Sos_simple_list<T> l = this;

    while( !l.empty() ) {
        l->head_ptr()->store( s );
        l = l->tail();
    }
}

//-------------------------------------------------------------------------Sos_simple_list<T>::load

template< class T >
Sos_simple_list<T>& Sos_simple_list<T>::load( istream& s )
{
    uint4 count = ( (uint4)s.get() << 24 )
                | ( (uint4)s.get() << 16 )
                | ( (uint4)s.get() <<  8 )
                |   (uint4)s.get();

    if( s.fail() )  count = 0;

    Sos_simple_list<T> l = *this;

    while( count ) {
        l.append( Sos_simple_list<T>( T().load( s ), 0 ) );
        count--;
    }

    return *this;
}


#endif
