/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#include "precomp.h"
//#define MODULE_NAME "sosmswin"
/*                                              (c) SOS GmbH Berlin
*/

#include "../kram/sysdep.h"
#if defined SYSTEM_WIN

#if defined SYSTEM_BORLAND
#   include <dir.h>            // MAX_PATH
#endif

#if defined SYSTEM_MICROSOFT
#   pragma warning( disable:4201 )  // warning C4201: nonstandard extension used : nameless struct/union
#endif

#ifndef STRICT
#   define STRICT
#endif
//#if defined SYSTEM_STARVIEW
//    #include <svwin.h>
// #else
#   include <windows.h>
//#endif

#include "../kram/sos.h"
#include "../kram/log.h"
#include "../kram/sosmswin.h"

using namespace std;
namespace sos {

extern HINSTANCE _hinstance;

//---------------------------------------------------------------------------------Mswin::hinstance

HINSTANCE Mswin::hinstance()
{
    // Hier nicht LOG aufrufen!
  //return Sysdepen::GethInst();
    return _hinstance;
}

//-----------------------------------------------------Mswin::Callback_instance::~Callback_instance

Mswin::Callback_instance::~Callback_instance()
{
    if( _instance ) {
        FreeProcInstance( _instance );
    }
}

//-------------------------------------------------------Mswin::Callback_instance::operator FARPROC

Mswin::Callback_instance::operator FARPROC ()
{
    if( !_instance ) {
        _instance = MakeProcInstance( _procedure, Mswin::hinstance() );
        if( !_instance ) {
            throw( Mswin::Error( "MakeProcInstance" ));
        }
    }
    return _instance;
}

//--------------------------------------------------------------------operator << ( HINSTANCE )

ostream& operator << ( ostream& s , HINSTANCE hinstance )
{
    char name [ MAXPATH + 1 ];
    int len = GetModuleFileName( hinstance, name, sizeof name );
    if( len )  s << name;
    else 
    {
        s << "HINSTANCE=" << (void*)hinstance;

#   if defined SYSTEM_WIN32
        long         error = GetLastError();
        char         code  [ 20 ];
        Dynamic_area text ( 500 );

        sprintf( code, "MSWIN-%08lX", (long)error );

        text.char_ptr()[ 0 ] = '\0';

        FormatMessage( FORMAT_MESSAGE_FROM_SYSTEM,
                       NULL,
                       error,
                       MAKELANGID( LANG_NEUTRAL, SUBLANG_DEFAULT ), //The user default language
                       text.char_ptr(), text.size(), NULL );

        char* p = text.char_ptr() + text.length();
        if( p > text.char_ptr()  &&  p[-1] == '\n' )  *--p = '\0';
        if( p > text.char_ptr()  &&  p[-1] == '\r' )  *--p = '\0';

        s << "[Fehler " << code << ' ' << text.char_ptr() << ']';
#   endif
    }

    return s;
}

} //namespace sos

#endif
