/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// sosole.h                                         1996 SOS GmbH Berlin
//                                                  Joacim Zschimmer

#ifndef __SOSOLE_H
#define __SOSOLE_H

namespace sos
{

#if defined SYSTEM_WIN32
// Fr Win16 muss UNICODE umgestellt werden.

/*
// Einige OLE-Typen:
struct          IDispatch;
typedef long    DISPID;
typedef         EXCEPINFO;
*/
#include <windows.h>

struct Ole_object;

typedef Sos_simple_array<Dyn_obj>  Sos_dyn_obj_array;



struct Ole_method : Sos_self_deleting
{
                                Ole_method              ( Ole_object* = NULL );
                               ~Ole_method              ();
                               
    void                        prepare                 ();
    void                        invoke                  ( Dyn_obj* result, const Sos_dyn_obj_array& );

    void                        throw_excepinfo         ( HRESULT, EXCEPINFO* );
    
    Fill_zero                  _zero_;
    Sos_string                 _name;
    Ole_object*                _object;
    DISPID                     _dispid;
};


struct Ole_object : Sos_self_deleting
{
                                Ole_object              ();
                                Ole_object              ( const Sos_string& class_name );
                               ~Ole_object              ();

    void                        prepare                 ();

#   if defined __SOSSTRNG_H
        Ole_method*             method                  ( const Sos_string& name )  { return method( c_str( name ) ); }
#   endif

    Ole_method*                 method                  ( const char* name ); 

    Fill_zero                  _zero_;
    Sos_string                 _name;
    Sos_string                 _class_name;
    Sos_simple_ptr_array< Ole_method > _methods;
    IDispatch*                 _pIDispatch;
    Dynamic_area               _hilfspuffer; 
};

#endif

} //namespace sos

#endif
