/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// sosregex.h

#ifndef __SOSREGEX_H
#define __SOSREGEX_H

#include <sysdep.h>

#if defined SYSTEM_WIN
#include <gregex.h>
#endif

#if defined SYSTEM_SOLARIS
#include <rw/cstring.h>
#include <rw/regexp.h>
typedef RWCRegexp Regex;
#endif

// Sos_regex - Klasse
struct Sos_regex : Regex
{
    Sos_regex( const Sos_string& str );

    void match( const Sos_string& to_match );

 private:
    Sos_string _regex_string; // Fr Fehlerausgaben
};

// Implementierung
Sos_regex::Sos_regex( const Sos_string& str )
:
    Regex( c_str( str ), 1 ),
    _regex_string( str )
{
}

void Sos_regex::match( const Sos_string& to_match )
{
    int len = length( to_match );
    unsigned int matched_length;

#if defined SYSTEM_WIN
    matched_length = Regex::match( c_str( to_match ), len, 0 );
#endif

#if defined SYSTEM_SOLARIS
    Regex::index( to_match, &matched_length, 0 );
#endif

    if ( matched_len != len )
    {
        Xc x( "SOS-1306", Msg_insertions( c_str(_regex_string), erg ) );
        throw x;
    }
}

#endif
