/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#include "precomp.h"
//#define MODULE_NAME "soswin"
// soswin.cpp                                           (c) SOS GmbH Berlin
//                                                          Joacim Zschimmer

#include "../kram/sysdep.h"

#if defined SYSTEM_STARVIEW         // Dieses Modul bentigt StarView

#include "../kram/sos.h"
#include "../kram/log.h"

#include "soswin.h"

using namespace std;
namespace sos {

//-------------------------------------------------------Key_code::normed_value

Key_code::Value Key_code::normed_value() const
{
    Value key_value = value();

    // Egal, ob linke oder rechte Shift/Cntrl-Taste gedrckt:
    if( key_value & Key_code::shift )  key_value |= Key_code::shift;
    if( key_value & Key_code::cntrl )  key_value |= Key_code::cntrl;

    return key_value;
}

//----------------------------------------------Abs_sos_window::~Abs_sos_window

Abs_sos_window::~Abs_sos_window()
{
}

//------------------------------------------------------Sos_window::~Sos_window

Sos_window::~Sos_window()
{
}

//------------------------------------Abs_sos_application::~Abs_sos_application

Abs_sos_application::~Abs_sos_application()
{
}

//------------------------------------Abs_sos_application::~Abs_sos_application

Abs_sos_application::Reschedule_status Abs_sos_application::reschedule()
{
    Reschedule_status s = reschedule_normal;
    _rescheduled++;
    s = _reschedule();
    if( s == reschedule_terminate )  _terminate = true;
    _rescheduled--;
    return s;
}

//---------------------------------------------Sos_application::Sos_application

Sos_application::Sos_application()
{
    _impl_ptr = window_system_ptr();
}

//--------------------------------------------Sos_application::~Sos_application

Sos_application::~Sos_application()
{
}

//----------------------------------------------------Sos_application::_execute

void Sos_application::_execute()
{
    _impl_ptr->execute();
}

//-------------------------------------------------Sos_application::_reschedule

Sos_application::Reschedule_status Sos_application::_reschedule()
{
    Reschedule_status s = _impl_ptr->reschedule();
    return s;
}

//-------------------------------------------------------Sos_application::_busy

void Sos_application::_busy( Bool b )
{
    _impl_ptr->busy( b );
}

//-------------------------------------------------------Sos_application::user_event_function

void Sos_application::user_event_function( User_event_function f )
{
    _impl_ptr->user_event_function( f );
}

} //namespace sos


#endif      // SYSTEM_STARVIEW
