/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// videobios.h
//                                                       (c) Joacim Zschimmer

#ifndef __VIDEOBIOS_H
#define __VIDEOBIOS_H

#include <bios.h>

#include "video.h"


struct Video_bios : public Video {
    Video_bios(int dummy = 0)
    {
#       ifdef __BORLANDC__
            _directvideo = 0;
#       endif
    }
    void write( Video_pos pos, char c, Video_attr attr )
    {
#       ifdef __BORLANDC__
            gotoxy( pos.column0() + 1, pos.line0() + 1 );
            textattr (attr);
            putch (c);
#        else
            set_cursor( pos );

            REGS r;
            r.h.ah = 0x09;
            r.h.al = c;
            r.h.bh = 0;
            r.h.bl = attr;
            r.x.cx = 1;
            int86( 10, &r, &r );
#       endif
    }
#   ifdef __BORLANDC__
        void write( Video_pos pos, char *text, int len, Video_attr attr );
        void fill ( Video_pos pos, char c    , int len, Video_attr attr );
#   endif
    void move (
        Subrange< int, 0, video_line_count >  ziel_zeilennr,
        Subrange< int, 0, video_line_count >  quell_zeilennr,
        Subrange< int, 0, video_line_count >  zeilenanz )
    {
#       ifdef __BORLANDC__
            movetext( 1                , 1 + quell_zeilennr,
                      video_line_length, 1 + quell_zeilennr + zeilenanz - 1,
                      1                , 1 + ziel_zeilennr );
#        else
            REGS r;
            if (quell_zeilennr > ziel_zeilennr) {
                r.h.ah = 0x06;
                r.h.ch = ziel_zeilennr;
                r.h.dh = quell_zeilennr;
            } else {
                r.h.ah = 0x07;
                r.h.ch = quell_zeilennr;
                r.h.dh = ziel_zeilennr;
            }
            r.h.al = zeilenanz;
            r.h.cl = 0;
            r.h.dl = 79;
            int86( 10, &r, &r );
#       endif
    }
};

#endif
