/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// videomem.h                                           (c) SOS GmbH Berlin

#ifndef __VIDEOMEM_H
#define __VIDEOMEM_H

#include <string.h>     // memmove (MS)
#include <memory.h>     // memmove (Borland)

#include <jzincl.h>
#include <video.h>


struct Video_memory : public Video {
    Video_memory(int dummy = 0);
    void write( Video_pos pos, char c, Video_attr attr )
    {
        _video_buffer[ pos.offset() ] = Video_char( c, attr );
    }
    void write( Video_pos pos, char *text, int len, Video_attr attr );
    void fill ( Video_pos pos, char c    , int len, Video_attr attr );
    void move (
        Subrange< int, 0, video_line_count >  ziel_zeilennr,
        Subrange< int, 0, video_line_count >  quell_zeilennr,
        Subrange< int, 0, video_line_count >  zeilenanz )  
    {
        memmove( _video_buffer + ziel_zeilennr  * video_line_length,
                 _video_buffer + quell_zeilennr * video_line_length,
                 zeilenanz * video_line_length * sizeof (Video_char) );
    }

    
  private:
    static Video_char *_video_buffer;

};

#endif
