/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: subsystem.h 5418 2007-12-06 14:13:38Z jz $        Joacim Zschimmer, Zschimmer GmbH, http://www.zschimmer.com

#ifndef __SCHEDULER_SUBSYSTEM_H
#define __SCHEDULER_SUBSYSTEM_H

namespace sos {
namespace scheduler {

//----------------------------------------------------------------------------------Subsystem_state

enum Subsystem_state
{
    subsys_not_initialized,
    subsys_initialized,
    subsys_loaded,
    subsys_active,
    subsys_stopped 
};

string                          string_from_subsystem_state ( Subsystem_state );

//----------------------------------------------------------------------------------------Subsystem

struct Subsystem : Scheduler_object, Non_cloneable
{
                                Subsystem                   ( Spooler* spooler, IUnknown* iunknown, Type_code t ) : Scheduler_object( spooler, iunknown, t ), _zero_(this+1) {}

              Scheduler_object::obj_name;

    virtual void                close                       ()                                      = 0;
    virtual bool                switch_subsystem_state      ( Subsystem_state );
    
    Subsystem_state             subsystem_state             () const                                { return _subsystem_state; }

  protected:
    virtual bool                subsystem_initialize        ();
    virtual bool                subsystem_load              ();
    virtual bool                subsystem_activate          ();

    Z_NORETURN void             throw_subsystem_state_error ( Subsystem_state, const string& message_text );
    void                        assert_subsystem_state      ( Subsystem_state, const string& message_text );
    void                    set_subsystem_state             ( Subsystem_state state )               { _subsystem_state = state; }

    Fill_zero                  _zero_;
    Subsystem_state            _subsystem_state;
};

//-------------------------------------------------------------------------------------------------

} //namespace scheduler
} //namespace sos

#endif
