/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: charset.h 5419 2007-12-06 14:15:42Z jz $

#ifndef __Z_CHARACTER_ENCODING_H
#define __Z_CHARACTER_ENCODING_H

namespace zschimmer {

//------------------------------------------------------------------------------------------Charset

struct Charset
{
    static const Charset*           for_name                ( const string& charset_name );

    virtual string                  name                    () const                                            = 0;
    
  //virtual size_t                  wchar_count_of_encoded  ( const string& ) const                             = 0;
    //virtual BSTR                    bstr_from_encoded       ( const string& ) const                             = 0;
    virtual HRESULT                 Encoded_to_bstr         ( const string&, BSTR* result ) const               = 0;
    virtual HRESULT                 Encoded_to_olechar      ( const string&, OLECHAR* result, size_t size ) const  = 0;
    virtual HRESULT                 Olechar_to_encoded      ( const OLECHAR*, size_t, string* result ) const       = 0;
    HRESULT                         Bstr_to_encoded         ( const BSTR bstr, string* result ) const             { return Olechar_to_encoded( bstr, SysStringLen( bstr ), result ); }
    string                          encoded_from_bstr       ( const BSTR ) const;

    /*
    virtual string                  utf8_from_encoded       ( const Byte* encoded, size_t ) const               = 0;
    virtual size_t                  encoded_length_of_utf8  ( const string& utf8 )                              = 0;
    virtual size_t                  utf8_to_encoded         ( const string&, Byte* encoded_result, int size ) const = 0;

    virtual size_t                  utf8_length_of_encoded  ( const Byte* encoded, size_t ) const               = 0;
    
  //virtual size_t                  iso8859_1_length_of_encoded( const Byte*, size_t ) const                   = 0;
    virtual string                  iso8859_1_from_encoded  ( const Byte*, size_t ) const                       = 0;
    virtual size_t                  iso8859_1_to_encoded    ( const string&, Byte* result, size_t ) const       = 0;

  protected:
    virtual HRESULT                 Encoded_to_wchar        ( const string&, wchar_t* result, size_t result_size ) const               = 0;
    */
};

//-------------------------------------------------------------------------------------------------

} //namespace zschimmer

#endif
