/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: java_Idispatch.cxx 4736 2007-01-16 10:56:47Z jz $

#include "z_java.h"

/*
#   ifdef _DEBUG
#       include "Debug/Idispatch.h"
#    else
#       include "Release/Idispatch.h"
#   endif
*/

using namespace zschimmer;
using namespace zschimmer::com;

//------------------------------------------------------------------------------Idispatch.construct

JNIEXPORT void JNICALL Java_sos_zschimmer_com_Idispatch_com_1construct( JNIEnv* jenv, jclass, jlong jidispatch )
{
    IDispatch* idispatch = (IDispatch*)jidispatch;

    if( idispatch )  idispatch->AddRef();
}

//-------------------------------------------------------------------------------Idispatch.destruct

JNIEXPORT void JNICALL Java_zschimmer_com_Idispatch_destruct( JNIEnv* jenv, jclass, jint jidispatch )
{
    IDispatch* idispatch = (IDispatch*)jidispatch;

    if( idispatch )  idispatch->Release();
}

//--------------------------------------------------------------------------Idispatch.com_method_id

JNIEXPORT jint JNICALL Java_zschimmer_com_Idispatch_com_1method_1id( JNIEnv* jenv, jobject jo, jint jidispatch, jint context, jstring name )
{
    try
    {
        HRESULT    hr;
        IDispatch* idispatch = (IDispatch*)jidispatch;
        Bstr       name_bstr = bstr_from_jstring( name );

        if( !idispatch )  throw_xc( "Idispatch::method_id" );

        DISPID dispid = 0;
        hr = idispatch->GetIDsOfNames( IID_NULL, &name_bstr, 1, STANDARD_LCID, &disp_id );
        if( FAILED(hr) )  throw_com( hr, "GetIDsOfNames", string_from_jstring(name).c_str() );

        return disp_id;
    }
    catch( const exception&  x ) { env.set_java_exception( x ); }
    catch( const _com_error& x ) { env.set_java_exception( x ); }
}

//-------------------------------------------------------------------------------Idispatch.com_call

JNIEXPORT jobject JNICALL Java_zschimmer_com_Idispatch_com_1call( JNIEnv* jenv, jobject jo, jint method_id, jint context )
{
    try
    {
        HRESULT    hr;
        IDispatch* idispatch = (IDispatch*)jidispatch;
        Variant    result;
        Excepinfo  excepinfo;
        UINT       arg_nr = -1;

        if( !idispatch )  throw_xc( "Idispatch::com_call" );

        hr = idispatch->Invoke( method_id, IID_NULL, STANDARD_LCID, context, params, &result, &excepinfo, &arg_nr );
        if( FAILED(hr) )  throw_com( hr, "Invoke", string_from_bstr(name).c_str() );

        return disp_id;
    }
    catch( const exception&  x ) { env.set_java_exception( x ); }
    catch( const _com_error& x ) { env.set_java_exception( x ); }
}

//-------------------------------------------------------------------------------------------------
