/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: loaded_module.h 3546 2005-04-03 08:30:29Z jz $

#ifndef __ZSCHIMMER_LOADED_MODULE
#define __ZSCHIMMER_LOADED_MODULE

namespace zschimmer {

//------------------------------------------------------------------------------------Loaded_module

struct Loaded_module : Object, Non_cloneable
{
/*
    struct Entry
    {
            Entry( const char* name );
            Entry( const string& name );
            Entry( const void* = NULL );

        Loaded_module          _loaded_module;
        string                 _name;
        void*                  _addr;
    };

    Loaded_module( const Entry[] entries )
    {
        for( const Entry& e = entries[0]; e->_addr | e->_name != ""; e++ )  add_entry( e );
    }
*/



                                Loaded_module               ( const string& filename = "" )         { set_filename( filename ); }
                               ~Loaded_module               ();


    void                    set_title                       ( const string& title )                 { _title = title; }

    void                        load                        ();
    void                        load                        ( const char* filename )                { set_filename( filename ); load(); }
    void                        load                        ( const string& filename )              { load( filename.c_str() ); }

    void                    set_filename                    ( const string& );
    string                      filename                    () const                                { return _filename; }

    void*                       addr_of                     ( const char* entry );
    void*                       addr_of                     ( const string& entry )                 { return addr_of( entry.c_str() ); } 

    void                        dont_unload                 ()                                      { _dont_unload = true; }

    friend ostream&             operator <<                 ( ostream& s, const Loaded_module& m )  { s << "Modul " << m._filename;  return s; }


  private:
    string                     _title;
    string                     _filename;
    bool                       _dont_unload;

#   ifdef Z_WINDOWS
                                operator HINSTANCE          ()                                      { return _handle; }
        HINSTANCE              _handle;
#    else
                                operator void*              ()                                      { return _handle; }
        void*                  _handle;
#   endif
};

//-------------------------------------------------------------------------------------------------

} //namespace zschimmer

#endif
