/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// rtf_parser.h                                         2000 Joacim Zschimmer
// $Id: rtf_parser.h 4451 2006-09-01 06:37:30Z jz $

#ifndef __RTF_PARSER_H
#define __RTF_PARSER_H

#include "../zschimmer.h"
#include <stdio.h>
#include <vector>
#include <stack>

namespace zschimmer {
namespace rtf {

struct Parser : Has_rtf_context
{
    struct Token
    {
                                Token                   ( Has_rtf_context* c )          : _zero_(this+1), _rtf(c) {}

        Fill_zero              _zero_;
        Entity                 _rtf;
        Source_pos             _pos;
    };


                                Parser                  ( const ptr<Doc>& );
                               ~Parser                  (); 

    void                        init                    ();
  //ptr<Doc>                    parse                   ( FILE* );
    void                        parse                   ();
    void                        parse_rest_of_group     ( Code outer_destination_code );
    void                        parse_destination       ();
    void                        parse_any_destination   ( Code, int param = 0 );
    void                        parse_non_destination   ();

    void                        parse_stylesheet        ();
    void                        parse_fonttbl           ();

    void                        ignore_group            ( int start_nesting = 0 );      // Parsiert {}-Verschachtelung zuende
    void                        ignore_rest_of_group    ()                              { ignore_group( 1 ); }
    void                        get_next_token          ();
    void                        eat                     ( Code );
    int                         eat_char                ();

    void                        restore_state           ();


    Fill_zero                  _zero_;
    string                     _filename;
    FILE*                      _input;                  // Eingabedatei
    const char*                _input_ptr;              // Oder Zeiger auf RTF-Dokument im Speicher
    int                        _next_char;
    Source_pos                 _char_pos;
    Source_pos                 _eaten_char_pos;
    Token                      _token;
    ptr<Doc>                   _doc;
    bool                       _non_doc_property_discovered;
    int                        _group_nesting;          // Aktuelle {}-Verschachtelung
  //bool                       _dont_ignore_pgdsctbl;   // eMail von Andreas Liebert 31.8.2006

    std::vector< Properties >  _properties_stack;
                      
  //std::stack<Destination_entity*>   _entity_stack;           // Fr {}-Verschachtelung

  //string                     _hilfspuffer;
    char*                      _hilfspuffer;
};

} //namespace rtf
} //namespace zschimmer

#endif
