/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: z_java.cxx 3546 2005-04-03 08:30:29Z jz $

#include "zschimmer.h"
#include "z_java.h"


namespace zschimmer {
namespace java {

//------------------------------------------------------------Registered_method::~Registered_method

Registered_method::~Registered_method()
{
    close();
}

//------------------------------------------------------------Registered_method::~Registered_method

void Registered_method::close()
{
    int ret = _jenv->UnregisterNatives( _jclass );
    if( ret < 0 )  _vm->throw_java( ret, "RegisterNatives" );
}

//---------------------------------------------------------------------------Registered_method::reg

void Registered_method::reg( jclass cls, const string& method_name, const string& signature, void* function )
{
    _jclass = cls;

    JNINativeMethod m;

    m.name      = method_name.c_str();
    m.signature = signature.c_str();
    m.fnPtr     = function;

    int ret = _jenv->RegisterNatives( _jclass, &m, 1 );
    if( ret < 0 )  _vm->throw_java( ret, "RegisterNatives" );
}

//-------------------------------------------------------------------------------------------------

} //nameepace java
} //namespace zschimmer
