/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: z_java.h 3546 2005-04-03 08:30:29Z jz $

#ifndef __Z_JAVA_H
#define __Z_JAVA_H

// Include-Path fr jni.h (z.B.):
// c:\Programme\Borland\jbuilder5\jdk1.3\include
// c:\Programme\Borland\jbuilder5\jdk1.3\include\win32
#include <jni.h>

#include "../zschimmer/zschimmer.h"
#include "../zschimmer/com.h"
#include "../zschimmer/z_com.h"

/*
void*   get_my_data         ( JNIEnv*, jobject );
void    set_java_exception  ( JNIEnv*, const char* what );
void    set_java_exception  ( JNIEnv*, const exception& );
void    set_java_exception  ( JNIEnv*, const _com_error& );
*/

namespace zschimmer {
namespace java {

//------------------------------------------------------------------------------------------Java_vm

struct Java_vm
{
    JNIEnv*                     env                         ();

    JavaVM*                    _vm;
}

//-------------------------------------------------------------------------------Registered_methods

struct Registered_methods, Non_cloneable
{
                                Registered_method           ( Java_vm* vm )                         : _fill_zero(this+1), { _java_vm = vm; }
                               ~Registered_method           ()                                      { close(); }

    void                        set_class                   ( jclass cls );
    void                        set_class                   ( const string& class_name );

    void                        add                         ( const string& method_name, const string& signature, void* function );
    void                        close                       ();

    Java_vm*                   _java_vm;
    jclass                     _jclass;
};

//-------------------------------------------------------------------------------------------------

} // namespace java
} // namespace zschimmer

#endif
